import WidthEllipsis from "@/components/widthEllipsis"
import { Statistic, Tag } from "antd"
import React from "react"

function columns12(): { label: string, fieldSHow?: { label: string, saveField: string, defaultValue: any[], data: any[] }, data: any[] }[] {


    return [
        {
            label: '基本信息',
            data: [
                {
                    title: '父游戏名称', dataIndex: 'parentGameName', label: '基本信息', align: 'center', width: 85, default: 1,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色名称', dataIndex: 'roleName', label: '基本信息', align: 'center', width: 85, default: 2,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色创建时间', dataIndex: 'roleTime', label: '基本信息', align: 'center', width: 125, default: 3,
                    render: (a: string, b: any) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色创角天数', dataIndex: 'roleCreateDayDiff', label: '基本信息', align: 'center', width: 60, default: 4,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: 'GS名称', dataIndex: 'gsName', label: '基本信息', align: 'center', width: 75, default: 5,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色所在区服名称', dataIndex: 'endServerName', label: '基本信息', align: 'center', width: 80, default: 6,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '服务时间', dataIndex: 'gsStartTime', label: '基本信息', align: 'center', width: 160, default: 7,
                    render: (a: string, b: any) => (<WidthEllipsis value={`${a}-${b?.gsEndTime}`} />)
                },
                {
                    title: '服务天数', dataIndex: 'gsServeDays', label: '基本信息', align: 'center', width: 45, default: 8,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '服务状态', dataIndex: 'serveStatus', label: '基本信息', align: 'center', width: 75, default: 9,
                    render: (a: boolean) => {
                        return a ? <Tag color="success" style={{ marginRight: 0 }}>服务完成</Tag> : <Tag color="processing" style={{ marginRight: 0 }}>服务中</Tag>
                    }
                }
            ]
        },
        {
            label: '角色数据信息',
            data: [
                {
                    title: '角色VIP等级', dataIndex: 'roleVip', label: '角色数据信息', align: 'center', width: 55, sorter: true, default: 10,
                },
                {
                    title: '角色游戏等级', dataIndex: 'roleLevel', label: '角色数据信息', align: 'center', width: 60, sorter: true, default: 11,
                },
                {
                    title: '角色攻击力', dataIndex: 'combatNum', label: '角色数据信息', align: 'right', width: 80, sorter: true, default: 12,
                },
                {
                    title: '国家', dataIndex: 'country', label: '角色数据信息', align: 'center', width: 60, sorter: true, default: 13,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色最近充值时间', dataIndex: 'lastOrderTime', label: '角色数据信息', align: 'center', width: 120, default: 14,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色最近活跃时间', dataIndex: 'activeTime', label: '角色数据信息', align: 'center', width: 120, default: 15,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色创角充值时间差', dataIndex: 'roleCreatePayDayDiff', label: '角色数据信息', align: 'center', width: 100, default: 16,
                    render: (a: string) => (<WidthEllipsis value={a} />)
                },
                {
                    title: '角色最近充值时间距今', dataIndex: 'lastOrderDayDiff', label: '角色数据信息', align: 'center', width: 65, default: 17,
                    render: (a: number) => (<span style={{ fontSize: 12, color: a > 5 ? 'red' : '#000' }}>{a || '--'}</span>)
                },
                {
                    title: '角色最近活跃时间距今', dataIndex: 'roleActiveDayDiff', label: '角色数据信息', align: 'center', width: 65, default: 18,
                    render: (a: number) => (<span style={{ fontSize: 12, color: a > 5 ? 'red' : '#000' }}>{a}</span>)
                },
                {
                    title: '角色累计充值金额', dataIndex: 'totalAmount', label: '角色数据信息', align: 'right', width: 70, sorter: true, default: 19,
                    render: (a: string) => <Statistic value={a || 0} />
                },
                {
                    title: '付费次数', dataIndex: 'gsCount', label: '角色数据信息', align: 'center', width: 70, sorter: true, default: 20,
                    render: (a: number) => a || 0
                },
                {
                    title: '付费金额', dataIndex: 'gsAmount', label: '角色数据信息', align: 'right', width: 70, sorter: true, default: 21,
                    render: (a: string) => <Statistic value={a || 0} />
                }
            ]
        }
    ]
}

export default columns12